import java.io.*;
import java.net.*;

public class acumulador {
  private static int pVotacion, pMonitor;
  public static int NPREF = 6; //desde cero hasta el cinco (incluidos)
  public static void main (String args[]) {
  
    //Verificamos la sintaxis
  	 if (args.length != 2) {
    	System.out.println("Usar: java acumulador <puerto_votacion> <puerto_monitor>\n");
    	System.exit(1);
    }
	 //Asignamos los argumentos como parametros.
	 pVotacion = Integer.parseInt(args[0]);
	 pMonitor = Integer.parseInt(args[1]);
	
	try {
		Server servidor = new Server();
		System.out.print("Server Running at: "+InetAddress.getLocalHost().getHostName());
		System.out.println(" ("+InetAddress.getLocalHost().getHostAddress()+")");
		
		//Servidor de votacion
		Thread t = new ThreadVotacion(pVotacion, servidor); //parametros al constructor 
		t.start(); //Iniciamos la hebra		

		//Servidor de monitor
		Thread t2 = new ThreadMonitor(pMonitor, servidor); //parametros al constructor
		t2.start(); //Iniciamos la hebra
		
		
		for(;;); //Servidores corriendo.
	
	} catch (Exception e) {		
	}
		
   System.exit(0);
  }
}

class ThreadHandler extends Thread {
	private Socket incoming;
	Server servidor;
	String type;
	
	public ThreadHandler(Socket incoming, Server servidor, String type) {
		this.incoming = incoming;	
		this.servidor = servidor;
		this.type = type;
	}
	
	public void run() {
		try {
			PrintWriter out = new PrintWriter(incoming.getOutputStream(), true);
			BufferedReader in = new BufferedReader(new InputStreamReader(incoming.getInputStream()));
		
			if( type.equals("votacion") ) {
				String line = in.readLine();//Bloqueados hasta recibir el voto
				//System.out.println("se recibe: "+line);
				try {
					servidor.set(Integer.parseInt(line));//Guardamos la votacion.
				} catch(NumberFormatException e) {
					//Error el cliente no ingresa un numero valido
				}
				//System.out.println(servidor.get());
			}
			if( type.equals("monitor") ) {
				out.println(servidor.get()); //Enviamos los resultados			
			}
			incoming.close();
		} catch (Exception e) {		
			e.printStackTrace();		
		}	
	}

}

class Server {
	private int[] voto =new int[acumulador.NPREF]; //votaciones en cero al iniciar.
   StringBuffer resultados = new StringBuffer();
	
	synchronized String get() {
		resultados.delete(0, resultados.length());
 		for(int i=0; i<acumulador.NPREF; i++) {
	 		resultados.append(voto[i]).append(" ");
		}
	 	//resultados.deleteCharAt(resultados.length());
    return resultados.toString();
  }
  
  synchronized void set(int value) {
    for(int i=0; i<acumulador.NPREF; i++) {
	 	if(value == i) voto[i]++;
	 }
  }
}

class ThreadVotacion extends Thread {
	private int pVotacion;
	Server servidor;
	String type = "votacion";
	
	public ThreadVotacion(int pVotacion, Server servidor) {
		this.pVotacion = pVotacion;
		this.servidor = servidor;
	}
		
	public void run() {
		try {			
			ServerSocket s = new ServerSocket(pVotacion);
			System.out.println("Server Port Votacion: "+s.getLocalPort());			
			
			for(;;) {
				Socket incoming = s.accept(); //Bloqueados hasta que llegue un cliente
				Thread t = new ThreadHandler(incoming, servidor, type); //parametros al constructor
				t.start(); //Iniciamos la hebra		
			} 
		} catch (Exception e) {		
		}		
	}
}

class ThreadMonitor extends Thread {
	private int pMonitor;
	Server servidor;
	String type = "monitor";
	
	public ThreadMonitor(int pMonitor, Server servidor) {
		this.pMonitor = pMonitor;
		this.servidor = servidor;
	}
		
	public void run() {
		try {			
			ServerSocket s = new ServerSocket(pMonitor);
			System.out.println("Server Port Monitor: "+s.getLocalPort());
			
			for(;;) {
				Socket incoming = s.accept(); //Bloqueados hasta que llegue un cliente
				Thread t = new ThreadHandler(incoming, servidor, type); //parametros al constructor
				t.start(); //Iniciamos la hebra		
			} 
		} catch (Exception e) {		
		}	
	}
}
